//
// aux_draw_box.c
//
// 99 - 01 - 09
//
static char version[] =
"$Id: aux_draw_box.c,v 1.1 1999/10/09 16:11:25 Fusz Exp $";

#include "oAux_exp.h"


/* drawbox:
 *
 * draws a rectangular box with the given x, y, and z ranges.
 * The box is axis-aligned.
 */
void auxDrawBox(
			 GLdouble x0, GLdouble x1, 
			 GLdouble y0, GLdouble y1,
			 GLdouble z0, GLdouble z1, 
			 GLenum type
			 )
{

	//
	// Normal-Vectors
	//
    static GLdouble NormalVector[6][3] = 
	{
        {-1.0, 0.0, 0.0}, 
		{0.0, 1.0, 0.0}, 
		{1.0, 0.0, 0.0},
        {0.0, -1.0, 0.0}, 
		{0.0, 0.0, 1.0}, 
		{0.0, 0.0, -1.0}
    };
    
	static GLint faces[6][4] = 
	{
        { 0, 1, 2, 3 }, // 0: left side
		{ 3, 2, 6, 7 }, // 1: top
		{ 7, 6, 5, 4 }, // 2: right side
        { 4, 5, 1, 0 }, // 3: botton
		{ 5, 6, 2, 1 }, // 4: back
		{ 7, 4, 0, 3 }  // 5: front
    };

	GLdouble v[8][3];
	
	GLdouble tmp;
    GLint i;

	//-----------------------------------------------------------------

    if (x0 > x1) 
	{
        tmp = x0; 
		x0 = x1; 
		x1 = tmp;
    }

    if (y0 > y1) 
	{
        tmp = y0;
		y0 = y1;
		y1 = tmp;
    }

    if (z0 > z1) 
	{
        tmp = z0; 
		z0 = z1; 
		z1 = tmp;
    }

    v[0][0] = v[1][0] = v[2][0] = v[3][0] = x0;
    v[4][0] = v[5][0] = v[6][0] = v[7][0] = x1;

    v[0][1] = v[1][1] = v[4][1] = v[5][1] = y0;
    v[2][1] = v[3][1] = v[6][1] = v[7][1] = y1;

    v[0][2] = v[3][2] = v[4][2] = v[7][2] = z0;
    v[1][2] = v[2][2] = v[5][2] = v[6][2] = z1;

	//
	// Draw the six surfaces
	//
    for (i = 0; i < 6; i++) 
	{

		glColor4d( 0.0, 1.0, 1.0, 1.0 );
		// type = GL_LINE_LOOP;
		if( i == 5 )
		{
			//type = GL_POLYGON;
			glColor4d( 0.0, 0.5, 0.0, 1.0 );
		}

        glBegin(GL_POLYGON );
		{   
			glNormal3dv( NormalVector[i] );

			glVertex3dv( v[ faces[i][0] ] );
			glVertex3dv( v[ faces[i][1] ] );
			glVertex3dv( v[ faces[i][2] ] );
			glVertex3dv( v[ faces[i][3] ] );
		}
        glEnd();
    }
}


void APIENTRY auxWireCube( GLdouble size )
{
	
	auxDrawBox(-size/(GLdouble)2., size/(GLdouble)2., 
				    -size/(GLdouble)2., size/(GLdouble)2.,
                    -size/(GLdouble)2., size/(GLdouble)2., 
					GL_POLYGON );
	
}
