/*
 * first_wnd_proc.c
 *
 * 98 - 08 - 27
 */

#include "first.h"



//=============================================================================

/*
 * The window procedure of the class TextWin
 */

LRESULT CALLBACK firstWindowProc (HWND hwnd, UINT iMsg,
                          WPARAM wParam, LPARAM lParam)
{
    //
    // Global Vars
    //
    // 
    // int tcxChar, tcyChar; [ width and height of a character ]  | W / - |
    // int iVscrollPos       [ Position of the verticall Thumb ]  | W / - |
    // int tPixX, tPixY      [ width and height of the text-window in PIXELs ]  | W / - |
    //

    TEXTMETRIC tm;
    HDC        hdc;
    
    LRESULT re = 0;

    //------------------------------------------------------------

    switch (iMsg)
    {
        case WM_CREATE:
            hdc = GetDC( hwnd );
            {
                SelectObject( hdc, GetStockObject(SYSTEM_FIXED_FONT) );
                GetTextMetrics( hdc, &tm );
                tcxChar = tm.tmAveCharWidth;
                tcyChar = tm.tmHeight;
            }
            ReleaseDC( hwnd, hdc );

            iVscrollPos = NUM_MESSAGES-1;
            SetScrollRange( hwnd, SB_VERT, 0, NUM_MESSAGES-1, FALSE );
            SetScrollPos(   hwnd, SB_VERT, iVscrollPos, TRUE );
            break;

        case WM_VSCROLL:
            firstVscroll( wParam );
            break;

        case WM_SIZE:

            //
            // Fenstergroesze in Pixeln abfragen
            //
            tPixX = LOWORD( lParam );
            tPixY = HIWORD( lParam );
            
            tcxBuffer = max( 1, tPixX / tcxChar );
            tcyBuffer = max( 1, tPixY / tcyChar );
            
            // sprintf( stdMessage, "tcyBuffer  %d", tcyBuffer );
            // wndInsertString( stdMessage );

            break;

        case WM_PAINT :
            firstPaint();
            break;

        case WM_DESTROY :
            PostQuitMessage (0) ;

            break;

        default:
            re = DefWindowProc (hwnd, iMsg, wParam, lParam);

    } // switch iMsg)

    return re;
}


