
//
// tk_wnd_proc_mouse.c
//
// 99 - 09 - 30
//
static char version[] =
"$Id: tk_wnd_proc_mouse.c,v 1.1 1999/11/21 19:56:06 Fusz Exp $";

#include <windows.h>
#include <gl/glu.h>
#include "oTk_intern.h"
#include "tk_wnd.h"
#include "oTkMouse.h"

int TkWndProcMouse( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{

    switch (message)
    {

    case WM_MOUSEMOVE:

        if( MouseMoveFunc )
        {
            GLenum mask;

            mask = 0;
            if (wParam & MK_LBUTTON)
            {
                mask |= TK_LEFTBUTTON;
            }
            if (wParam & MK_MBUTTON)
            {
                mask |= TK_MIDDLEBUTTON;
            }
            if (wParam & MK_RBUTTON)
            {
                mask |= TK_RIGHTBUTTON;
            }

            if ((*MouseMoveFunc)( LOWORD(lParam), HIWORD(lParam), mask ))
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    case WM_LBUTTONDOWN:

        SetCapture(hWnd);
        printf( "WM_LBUTTONDOWN\n" );
        
        if (MouseDownFunc)
        {
            if ( (*MouseDownFunc)(LOWORD(lParam), HIWORD(lParam),
                                  TK_LEFTBUTTON) )
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    case WM_LBUTTONUP:

        ReleaseCapture();

        if (MouseUpFunc)
        {
            if ((*MouseUpFunc)(LOWORD(lParam), HIWORD(lParam), TK_LEFTBUTTON))
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    case WM_MBUTTONDOWN:

        SetCapture(hWnd);

        if (MouseDownFunc)
        {
            if ((*MouseDownFunc)(LOWORD(lParam), HIWORD(lParam),
                                 TK_MIDDLEBUTTON))
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    case WM_MBUTTONUP:

        ReleaseCapture();

        if (MouseUpFunc)
        {
            if ((*MouseUpFunc)(LOWORD(lParam), HIWORD(lParam),
                               TK_MIDDLEBUTTON))
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    case WM_RBUTTONDOWN:

        SetCapture(hWnd);

        if (MouseDownFunc)
        {
            if ((*MouseDownFunc)(LOWORD(lParam), HIWORD(lParam),
                                 TK_RIGHTBUTTON))
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    case WM_RBUTTONUP:

        ReleaseCapture();

        if (MouseUpFunc)
        {
            if ((*MouseUpFunc)(LOWORD(lParam), HIWORD(lParam),
                               TK_RIGHTBUTTON))
            {
                ForceRedraw( hWnd );
            }
        }
        return (0);

    }

}


